/*
 * This file generated automatically from hwc.xml by c_client.py.
 * Edit at your peril.
 */

/**
 * @defgroup XCB_HWC_API XCB HWC API
 * @brief HWC XCB Protocol Implementation.
 * @{
 **/

#ifndef __HWC_H
#define __HWC_H

#include "xcb.h"
#include "xproto.h"
#include "render.h"
#include "randr.h"

#ifdef __cplusplus
extern "C" {
#endif

#define XCB_HWC_MAJOR_VERSION 2
#define XCB_HWC_MINOR_VERSION 0
  
extern xcb_extension_t xcb_hwc_id;

typedef enum xcb_hwc_composite_method_t {
    XCB_HWC_COMPOSITE_METHOD_DEFAULT = 0,
    XCB_HWC_COMPOSITE_METHOD_SCALE_FULL = 1,
    XCB_HWC_COMPOSITE_METHOD_SCALE_TIGHT = 2,
    XCB_HWC_COMPOSITE_METHOD_DRIVER = 3,
    XCB_HWC_COMPOSITE_METHOD_FILL = 4
} xcb_hwc_composite_method_t;

/**
 * @brief xcb_hwc_draw_info_t
 **/
typedef struct xcb_hwc_draw_info_t {
    uint32_t drawable; /**<  */
    int16_t  srcX; /**<  */
    int16_t  srcY; /**<  */
    uint16_t srcWidth; /**<  */
    uint16_t srcHeight; /**<  */
    int16_t  dstX; /**<  */
    int16_t  dstY; /**<  */
    uint16_t dstWidth; /**<  */
    uint16_t dstHeight; /**<  */
    int32_t  composite_methods; /**<  */
} xcb_hwc_draw_info_t;

/**
 * @brief xcb_hwc_draw_info_iterator_t
 **/
typedef struct xcb_hwc_draw_info_iterator_t {
    xcb_hwc_draw_info_t *data; /**<  */
    int                  rem; /**<  */
    int                  index; /**<  */
} xcb_hwc_draw_info_iterator_t;

/**
 * @brief xcb_hwc_query_version_cookie_t
 **/
typedef struct xcb_hwc_query_version_cookie_t {
    unsigned int sequence; /**<  */
} xcb_hwc_query_version_cookie_t;

/** Opcode for xcb_hwc_query_version. */
#define XCB_HWC_QUERY_VERSION 0

/**
 * @brief xcb_hwc_query_version_request_t
 **/
typedef struct xcb_hwc_query_version_request_t {
    uint8_t  major_opcode; /**<  */
    uint8_t  minor_opcode; /**<  */
    uint16_t length; /**<  */
    uint32_t major_version; /**<  */
    uint32_t minor_version; /**<  */
} xcb_hwc_query_version_request_t;

/**
 * @brief xcb_hwc_query_version_reply_t
 **/
typedef struct xcb_hwc_query_version_reply_t {
    uint8_t  response_type; /**<  */
    uint8_t  pad0; /**<  */
    uint16_t sequence; /**<  */
    uint32_t length; /**<  */
    uint32_t major_version; /**<  */
    uint32_t minor_version; /**<  */
} xcb_hwc_query_version_reply_t;

/**
 * @brief xcb_hwc_open_cookie_t
 **/
typedef struct xcb_hwc_open_cookie_t {
    unsigned int sequence; /**<  */
} xcb_hwc_open_cookie_t;

/** Opcode for xcb_hwc_open. */
#define XCB_HWC_OPEN 1

/**
 * @brief xcb_hwc_open_request_t
 **/
typedef struct xcb_hwc_open_request_t {
    uint8_t          major_opcode; /**<  */
    uint8_t          minor_opcode; /**<  */
    uint16_t         length; /**<  */
    uint8_t          pad0[4]; /**<  */
    xcb_randr_crtc_t crtc_id; /**<  */
} xcb_hwc_open_request_t;

/**
 * @brief xcb_hwc_open_reply_t
 **/
typedef struct xcb_hwc_open_reply_t {
    uint8_t  response_type; /**<  */
    uint8_t  pad0; /**<  */
    uint16_t sequence; /**<  */
    uint32_t length; /**<  */
    uint32_t maxlayer; /**<  */
} xcb_hwc_open_reply_t;

/** Opcode for xcb_hwc_set_drawable. */
#define XCB_HWC_SET_DRAWABLE 2

/**
 * @brief xcb_hwc_set_drawable_request_t
 **/
typedef struct xcb_hwc_set_drawable_request_t {
    uint8_t          major_opcode; /**<  */
    uint8_t          minor_opcode; /**<  */
    uint16_t         length; /**<  */
    xcb_randr_crtc_t crtc_id; /**<  */
    uint32_t         count; /**<  */
} xcb_hwc_set_drawable_request_t;

/** Opcode for xcb_hwc_select_input. */
#define XCB_HWC_SELECT_INPUT 3

/**
 * @brief xcb_hwc_select_input_request_t
 **/
typedef struct xcb_hwc_select_input_request_t {
    uint8_t      major_opcode; /**<  */
    uint8_t      minor_opcode; /**<  */
    uint16_t     length; /**<  */
    xcb_window_t window; /**<  */
    uint32_t     mask; /**<  */
} xcb_hwc_select_input_request_t;

/** Opcode for xcb_hwc_configure_notify. */
#define XCB_HWC_CONFIGURE_NOTIFY 0

/**
 * @brief xcb_hwc_configure_notify_event_t
 **/
typedef struct xcb_hwc_configure_notify_event_t {
    uint8_t          response_type; /**<  */
    xcb_randr_crtc_t crtc_id; /**<  */
    uint16_t         sequence; /**<  */
    uint32_t         maxlayer; /**<  */
} xcb_hwc_configure_notify_event_t;

/**
 * Get the next element of the iterator
 * @param i Pointer to a xcb_hwc_draw_info_iterator_t
 *
 * Get the next element in the iterator. The member rem is
 * decreased by one. The member data points to the next
 * element. The member index is increased by sizeof(xcb_hwc_draw_info_t)
 */

/*****************************************************************************
 **
 ** void xcb_hwc_draw_info_next
 ** 
 ** @param xcb_hwc_draw_info_iterator_t *i
 ** @returns void
 **
 *****************************************************************************/
 
void
xcb_hwc_draw_info_next (xcb_hwc_draw_info_iterator_t *i  /**< */);

/**
 * Return the iterator pointing to the last element
 * @param i An xcb_hwc_draw_info_iterator_t
 * @return  The iterator pointing to the last element
 *
 * Set the current element in the iterator to the last element.
 * The member rem is set to 0. The member data points to the
 * last element.
 */

/*****************************************************************************
 **
 ** xcb_generic_iterator_t xcb_hwc_draw_info_end
 ** 
 ** @param xcb_hwc_draw_info_iterator_t i
 ** @returns xcb_generic_iterator_t
 **
 *****************************************************************************/
 
xcb_generic_iterator_t
xcb_hwc_draw_info_end (xcb_hwc_draw_info_iterator_t i  /**< */);

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 * 
 */

/*****************************************************************************
 **
 ** xcb_hwc_query_version_cookie_t xcb_hwc_query_version
 ** 
 ** @param xcb_connection_t *c
 ** @param uint32_t          major_version
 ** @param uint32_t          minor_version
 ** @returns xcb_hwc_query_version_cookie_t
 **
 *****************************************************************************/
 
xcb_hwc_query_version_cookie_t
xcb_hwc_query_version (xcb_connection_t *c  /**< */,
                       uint32_t          major_version  /**< */,
                       uint32_t          minor_version  /**< */);

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 * 
 * This form can be used only if the request will cause
 * a reply to be generated. Any returned error will be
 * placed in the event queue.
 */

/*****************************************************************************
 **
 ** xcb_hwc_query_version_cookie_t xcb_hwc_query_version_unchecked
 ** 
 ** @param xcb_connection_t *c
 ** @param uint32_t          major_version
 ** @param uint32_t          minor_version
 ** @returns xcb_hwc_query_version_cookie_t
 **
 *****************************************************************************/
 
xcb_hwc_query_version_cookie_t
xcb_hwc_query_version_unchecked (xcb_connection_t *c  /**< */,
                                 uint32_t          major_version  /**< */,
                                 uint32_t          minor_version  /**< */);

/**
 * Return the reply
 * @param c      The connection
 * @param cookie The cookie
 * @param e      The xcb_generic_error_t supplied
 *
 * Returns the reply of the request asked by
 * 
 * The parameter @p e supplied to this function must be NULL if
 * xcb_hwc_query_version_unchecked(). is used.
 * Otherwise, it stores the error if any.
 *
 * The returned value must be freed by the caller using free().
 */

/*****************************************************************************
 **
 ** xcb_hwc_query_version_reply_t * xcb_hwc_query_version_reply
 ** 
 ** @param xcb_connection_t                *c
 ** @param xcb_hwc_query_version_cookie_t   cookie
 ** @param xcb_generic_error_t            **e
 ** @returns xcb_hwc_query_version_reply_t *
 **
 *****************************************************************************/
 
xcb_hwc_query_version_reply_t *
xcb_hwc_query_version_reply (xcb_connection_t                *c  /**< */,
                             xcb_hwc_query_version_cookie_t   cookie  /**< */,
                             xcb_generic_error_t            **e  /**< */);

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 * 
 */

/*****************************************************************************
 **
 ** xcb_hwc_open_cookie_t xcb_hwc_open
 ** 
 ** @param xcb_connection_t *c
 ** @param xcb_randr_crtc_t  crtc_id
 ** @returns xcb_hwc_open_cookie_t
 **
 *****************************************************************************/
 
xcb_hwc_open_cookie_t
xcb_hwc_open (xcb_connection_t *c  /**< */,
              xcb_randr_crtc_t  crtc_id  /**< */);

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 * 
 * This form can be used only if the request will cause
 * a reply to be generated. Any returned error will be
 * placed in the event queue.
 */

/*****************************************************************************
 **
 ** xcb_hwc_open_cookie_t xcb_hwc_open_unchecked
 ** 
 ** @param xcb_connection_t *c
 ** @param xcb_randr_crtc_t  crtc_id
 ** @returns xcb_hwc_open_cookie_t
 **
 *****************************************************************************/
 
xcb_hwc_open_cookie_t
xcb_hwc_open_unchecked (xcb_connection_t *c  /**< */,
                        xcb_randr_crtc_t  crtc_id  /**< */);

/**
 * Return the reply
 * @param c      The connection
 * @param cookie The cookie
 * @param e      The xcb_generic_error_t supplied
 *
 * Returns the reply of the request asked by
 * 
 * The parameter @p e supplied to this function must be NULL if
 * xcb_hwc_open_unchecked(). is used.
 * Otherwise, it stores the error if any.
 *
 * The returned value must be freed by the caller using free().
 */

/*****************************************************************************
 **
 ** xcb_hwc_open_reply_t * xcb_hwc_open_reply
 ** 
 ** @param xcb_connection_t       *c
 ** @param xcb_hwc_open_cookie_t   cookie
 ** @param xcb_generic_error_t   **e
 ** @returns xcb_hwc_open_reply_t *
 **
 *****************************************************************************/
 
xcb_hwc_open_reply_t *
xcb_hwc_open_reply (xcb_connection_t       *c  /**< */,
                    xcb_hwc_open_cookie_t   cookie  /**< */,
                    xcb_generic_error_t   **e  /**< */);

int
xcb_hwc_set_drawable_sizeof (const void  *_buffer  /**< */);

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 * 
 * This form can be used only if the request will not cause
 * a reply to be generated. Any returned error will be
 * saved for handling by xcb_request_check().
 */

/*****************************************************************************
 **
 ** xcb_void_cookie_t xcb_hwc_set_drawable_checked
 ** 
 ** @param xcb_connection_t          *c
 ** @param xcb_randr_crtc_t           crtc_id
 ** @param uint32_t                   count
 ** @param const xcb_hwc_draw_info_t *draw_info
 ** @returns xcb_void_cookie_t
 **
 *****************************************************************************/
 
xcb_void_cookie_t
xcb_hwc_set_drawable_checked (xcb_connection_t          *c  /**< */,
                              xcb_randr_crtc_t           crtc_id  /**< */,
                              uint32_t                   count  /**< */,
                              const xcb_hwc_draw_info_t *draw_info  /**< */);

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 * 
 */

/*****************************************************************************
 **
 ** xcb_void_cookie_t xcb_hwc_set_drawable
 ** 
 ** @param xcb_connection_t          *c
 ** @param xcb_randr_crtc_t           crtc_id
 ** @param uint32_t                   count
 ** @param const xcb_hwc_draw_info_t *draw_info
 ** @returns xcb_void_cookie_t
 **
 *****************************************************************************/
 
xcb_void_cookie_t
xcb_hwc_set_drawable (xcb_connection_t          *c  /**< */,
                      xcb_randr_crtc_t           crtc_id  /**< */,
                      uint32_t                   count  /**< */,
                      const xcb_hwc_draw_info_t *draw_info  /**< */);

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 * 
 * This form can be used only if the request will not cause
 * a reply to be generated. Any returned error will be
 * saved for handling by xcb_request_check().
 */

/*****************************************************************************
 **
 ** xcb_void_cookie_t xcb_hwc_select_input_checked
 ** 
 ** @param xcb_connection_t *c
 ** @param xcb_window_t      window
 ** @param uint32_t          mask
 ** @returns xcb_void_cookie_t
 **
 *****************************************************************************/
 
xcb_void_cookie_t
xcb_hwc_select_input_checked (xcb_connection_t *c  /**< */,
                              xcb_window_t      window  /**< */,
                              uint32_t          mask  /**< */);

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 * 
 */

/*****************************************************************************
 **
 ** xcb_void_cookie_t xcb_hwc_select_input
 ** 
 ** @param xcb_connection_t *c
 ** @param xcb_window_t      window
 ** @param uint32_t          mask
 ** @returns xcb_void_cookie_t
 **
 *****************************************************************************/
 
xcb_void_cookie_t
xcb_hwc_select_input (xcb_connection_t *c  /**< */,
                      xcb_window_t      window  /**< */,
                      uint32_t          mask  /**< */);


#ifdef __cplusplus
}
#endif

#endif

/**
 * @}
 */
